/* Implementation: stats.c
   Auteurs       : Enseignants du projet C
   Version       : 1.0
   Implementation du module permettant de grer des statistiques
   sur un ensemble de donnes fourni par l'utilisateur
*/

#include <stdio.h>
#include <stdlib.h>
/* Pour INT_MAX et INT_MIN */
#include <limits.h>
#include "stats.h"


/*--------------------------------------------------*/
/*             DECLARATIONS GLOBALES                */
/*--------------------------------------------------*/
static int    nb_valeurs;  /*Nombre de valeurs entres*/
static int    min;        /*le minimum de l'ensemble*/
static int    max;        /*le maximum de l'ensemble*/
static float  total;      /*le total de l'ensemble*/


/*----------------------------------------------------*/
/*                     FONCTIONS                      */
/*----------------------------------------------------*/


/* Initialisation du module
*  On alloue une place mmoire de taille size
*  Initialisation des variables statistiques
*/
void stat_init()
{
	min      = INT_MAX;
	max      = INT_MIN;
	total     = 0;
        nb_valeurs = 0;
}

/* Destruction de l'ensemble
   Rien dans l'implmentation actuelle du paquet, mais si un jour on
   veut faire des analyses plus fines, on risque
   d'avoir  allouer de la mmoire, et il faudrait la dsallouer ici.

   Une fonction vide comme celle-ci permet de s'assurer de la
   compatibilit avec les versions futures pour les gens qui ont
   respect l'API.
*/
void stat_end()
{

}

/* Remplissage de l'ensemble  traiter
*  Une valeur value est ajoute  la fois
*/
void stat_entrer_valeur(int value)
{
	if(value < min) min = value;
	if(value > max) max = value;
	total              += value;
	nb_valeurs++;
}


/* Accs au minimum de l'ensemble
   Renvoie le minimum
*/
int stat_min()
{
	return min;
}

/* Accs au maximum de l'ensemble
   Renvoie le maximum
*/
int stat_max()
{
	return max;
}

/* Accs  la moyenne de l'ensemble
   Renvoie la moyenne
*/
float stat_moyenne()
{
	return total/nb_valeurs;
}
