/* Spcification : stats_listes.c
   Auteurs       : Enseignants du projet C
   Version       : 1.0
   Implementation du module permettant de grer des statistiques
   sur une liste d'entiers fourni par l'utilisateur
*/

#include <stdio.h>
#include <stdlib.h>
#include "stats_listes.h"
#include "stats.h"

/*
  "wrapper" pour stat_entrer_valeur, pour pouvoir
  l'utiliser avec l'itrateur "parcours" fourni par le paquet liste.
*/
static void entrer_valeur_ptr(int * v) {
	stat_entrer_valeur(*v);
}

/* Accs au minimum de la liste
   Renvoie le minimum
   Prcondition : l'ensemble a t initialis via stat_init();
*/
int stat_listes_min(const liste* const l)
{
	int resultat;
	stat_init();
	parcours(entrer_valeur_ptr, l);
        resultat = stat_min();
	stat_end();
	return resultat;
}

/* Accs au maximum de la liste
   Renvoie le maximum
   Prcondition : l'ensemble a t initialis via stat_init();
*/
int stat_listes_max(const liste* const l)
{
	int resultat;
	stat_init();
	parcours(entrer_valeur_ptr, l);
	resultat = stat_max();
	stat_end();
	return resultat;
}

/* Accs  la moyenne de la liste
   Renvoie la moyenne
   Prcondition : l'ensemble a t initialis via stat_init();
*/
float stat_listes_moyenne(const liste* const l)
{
	int resultat;
	stat_init();
	parcours(entrer_valeur_ptr, l);
	resultat = stat_moyenne();
	stat_end();
	return resultat;
}
